module cpu(
  input wire clk,
  input wire resetn,
  output wire [7:0] debug_port1,
  output wire [7:0] debug_port2,
  output wire [7:0] debug_port3
  );

localparam code_width = 32;
localparam code_width_l2b = $clog2(code_width/8);
localparam code_words = 512;
localparam code_words_l2 = $clog2(code_words);
localparam code_addr_width = code_words_l2 - code_width_l2b;

  reg [code_width - 1:0]  code_mem[code_words - 1:0];
  reg [code_width - 1:0]  code_mem_rd;
  wire [code_addr_width - 1:0] code_addr;

  initial begin
    //  These are garbage.  You should replace with your code.
    code_mem[0] <= 32'hff124500;
    code_mem[1] <= 32'hff124501;
    code_mem[2] <= 32'hff124567;
  end
  always @(posedge clk) begin
    code_mem_rd <= code_mem[code_addr];
  end

  reg [31:0]  pc;

  assign debug_port1 = pc[9:2];
  assign debug_port2 = code_mem_rd[15:8];
  assign debug_port3 = code_mem_rd[7:0];
  
  assign code_addr = pc[(code_addr_width + 2) - 1:2];

  always @(posedge clk) begin
    if (!resetn) begin
      pc <= 0;
    end else begin
      if (pc > 8)
        pc <= 0;
      else
        pc <= pc + 4;
    end
  end

endmodule
